package com.jeequan.jeepay.components.mq.model;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jeequan.jeepay.components.mq.constant.MQSendTypeEnum;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * TODO
 * 账户余额消息mq
 * @author crystal
 * @date 2023/12/19 14:37
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class AccountBalanceMQ extends AbstractMQ {

    /** 【！重要配置项！】 定义MQ名称 **/
    public static final String MQ_NAME = "QUEUE_ACCOUNT_BALANCE_MCH";

    /** 内置msg 消息体定义 **/
    private MsgPayload payload;

    /**  【！重要配置项！】 定义Msg消息载体 **/
    @Data
    @AllArgsConstructor
    public static class MsgPayload {
        /** 账户号 **/
        private String accountNo;
    }

    @Override
    public String getMQName() {
        return MQ_NAME;
    }

    @Override
    public MQSendTypeEnum getMQType() {
        return MQSendTypeEnum.QUEUE;
    }

    @Override
    public String toMessage() {
        return JSONObject.toJSONString(payload);
    }


    /**  【！重要配置项！】 构造MQModel , 一般用于发送MQ时 **/
    public static AccountBalanceMQ build(String accountNo){
        return new AccountBalanceMQ(new MsgPayload(accountNo));
    }

    /** 解析MQ消息， 一般用于接收MQ消息时 **/
    public static MsgPayload parse(String msg){
        return JSON.parseObject(msg, MsgPayload.class);
    }

    /** 定义 IMQReceiver 接口： 项目实现该接口则可接收到对应的业务消息  **/
    public interface IMQReceiver{
        void receive(MsgPayload payload);
    }
}
